from .download import download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_file(xz_url + "gp_geo_nodes_mods.blend",down_path)
download_file(xz_url + "group_pro.py",down_path)

bl_info = {
    "name": "Group Pro",
    "description": "Merge objects into groups and work on them in nondestructive way",
    "description": "yulululul",
    "author": "Bartosz Styperek",
    "version": (2, 3, 4),
    "blender": (3, 6, 0),
    "location": "View3D, Right Sidebar > Group Pro tab (can be changed in preferences); Hotkey: Ctrl+X",
    "doc_url": "https://joseconseco.github.io/GroupProDocs/",
    "tracker_url": "https://discord.gg/cxZDbqH",
    "category": "Object"}

#DONE: add make meshes unique in make unique
#DONE: Editing group fails if it is child of something...
#DONE: Remade PIE
#DONE KIND OF (some random loc/rot are there): Adjust child of obj when closing its parent inside group
#DONE: convert to geometry - handle parents child
#DONE: add open under cursor for neseted groups
#DONE:  creating group - new group should be assigned to already edited group
#DONE: initialize - should calculate bbox maybe, and change emptiees size tooo...
#DONE: shift open - opens all groups inside
#DONE: shift D vs alt D - instance vs duplicate
#DONE: override derault ctrl+c ctrl+v
#DONE: fix children when changing group origin
#DONE: MAKE CHANGE ORIGING work on all selected objs?
#DONE: fix dissolve maxDepth not working (cos of pool)
#WIP: fix children sometemies moving (remake oll mat_world to - matrix_local = matrix_parent_inverse * matrix_basis,  matrix_local = matrix_parent_inverse * matrix_basis)
#DONE: add integration with BCutter maybe? Added nested groups
#DONE: add integration with BCutter maybe? Added nested groups
#DONE: fixed hidden bbox objects visiblilty_get


# load and reload submodules
##################################

if "bpy" in locals():
    import importlib
    importlib.reload(key_map_prefs)
    importlib.reload(linked_helpers)
    importlib.reload(draw_gpu_debug)
    importlib.reload(group_pro)
    importlib.reload(gp_props)
    importlib.reload(auto_load)
    importlib.reload(gp_ui)
    importlib.reload(vieport_overlays)
    importlib.reload(helpers_group)
    importlib.reload(update_addon)
    importlib.reload(tree_structure)
    importlib.reload(gp_proxies)
    importlib.reload(gp_modifiers)
    importlib.reload(array_mod_utils)
else:
    from . import key_map_prefs
    from .linked_edit import linked_helpers
    from .screen_drawing import draw_gpu_debug
    from . import group_pro
    from . import gp_props
    from . import auto_load
    from . import gp_ui
    from .screen_drawing import vieport_overlays
    from . import helpers_group
    from . import update_addon
    from . import tree_structure
    from . import gp_proxies
    from . import gp_modifiers
    from . import array_mod_utils


import bpy
from . import auto_load
from bpy.app.handlers import persistent
from .helpers_group import update_all_bb_objs, update_all_coll_colors
auto_load.init()


handleDynamicBBox = []
handleTxt = []

def make_link_group(self,context):
    layout = self.layout
    layout.separator()
    # layout.operator_context = "INVOKE_DEFAULT"
    layout.operator('object.link_to_group')

@persistent
def load_handle_gpr_bbox(dummy):
    update_all_bb_objs()
    update_all_coll_colors()

# create render_pre hander that will switch objects to proxy state
@persistent
def render_pre_handler(scene):
    addon_prefs = helpers_group.get_addon_preferences()
    if addon_prefs.proxy_switch_on_render:
        for obj in scene.objects:
            if obj.type == 'EMPTY' and obj.instance_collection and obj.instance_collection.gp_props.to_parent:
                switch_coll = obj.instance_collection.gp_props.to_parent
                if switch_coll:
                    obj.instance_collection = switch_coll

# create render_post hander that will switch proxy objects to their original state
@persistent
def render_post_handler(scene):
    addon_prefs = helpers_group.get_addon_preferences()
    if addon_prefs.proxy_switch_on_render:
        for obj in scene.objects:
            if obj.type == 'EMPTY' and obj.instance_collection and obj.instance_collection.gp_props.to_proxy:
                switch_coll = obj.instance_collection.gp_props.to_proxy
                if switch_coll:
                    obj.instance_collection = switch_coll

def register():
    auto_load.register()

    addon_prefs = helpers_group.get_addon_preferences()
    addon_prefs.update_text = ''

    #### Edite MOde BBox Updates #########
    if vieport_overlays.handler_reset_edit_bbox not in bpy.app.handlers.depsgraph_update_post:
        bpy.app.handlers.load_pre.append(vieport_overlays.handler_reset_edit_bbox)

    if vieport_overlays.gpro_scene_update not in bpy.app.handlers.depsgraph_update_post:
        bpy.app.handlers.depsgraph_update_post.append(vieport_overlays.gpro_scene_update)

    if vieport_overlays.gpro_undo_handler not in bpy.app.handlers.undo_post:
        bpy.app.handlers.undo_post.append(vieport_overlays.gpro_undo_handler)

    if vieport_overlays.gpro_redo_handler not in bpy.app.handlers.redo_post:
        bpy.app.handlers.redo_post.append(vieport_overlays.gpro_redo_handler)
    #### Edite MOde BBox Updates #########


    if handleDynamicBBox:
        bpy.types.SpaceView3D.draw_handler_remove(handleDynamicBBox[0], 'WINDOW')
    handleDynamicBBox[:] = [bpy.types.SpaceView3D.draw_handler_add(vieport_overlays.DrawDynamicBBox, (), 'WINDOW', 'POST_VIEW')]

    if handleTxt:
        bpy.types.SpaceView3D.draw_handler_remove(handleTxt[0], 'WINDOW')
    handleTxt[:] = [bpy.types.SpaceView3D.draw_handler_add(vieport_overlays.drawText, (), 'WINDOW', 'POST_PIXEL')]

    gp_props.register_props()

    # key_map_prefs.register_keymap()
    # dealay register_keymap so that it sees wm.keyconfigs.default - and can properly override it
    # bpy.app.timers.register(key_map_prefs.register_keymap, first_interval=1)
    # WARN: somehow if loading blend file, timer delayed register hack wont work... Use sleep instead
    import time
    time.sleep(.1)
    key_map_prefs.register_keymap()

    key_map_prefs.update_panel(None, bpy.context)

    bpy.app.handlers.load_post.append(load_handle_gpr_bbox)
    bpy.types.VIEW3D_MT_make_links.append(make_link_group)

    bpy.app.handlers.render_pre.append(render_pre_handler)
    bpy.app.handlers.render_post.append(render_post_handler)

    print("Registered Group Pro")

def unregister():
    bpy.types.VIEW3D_MT_make_links.remove(make_link_group)

    bpy.app.handlers.render_pre.remove(render_pre_handler)
    bpy.app.handlers.render_post.remove(render_post_handler)
    bpy.app.handlers.load_post.remove(load_handle_gpr_bbox)

    key_map_prefs.unregister_keymap()

    if handleDynamicBBox:
        bpy.types.SpaceView3D.draw_handler_remove(handleDynamicBBox[0], 'WINDOW')
        handleDynamicBBox[:] = []
    if handleTxt:
        bpy.types.SpaceView3D.draw_handler_remove(handleTxt[0], 'WINDOW')
        handleTxt[:] = []

    #### Edite MOde BBox Updates #########
    if vieport_overlays.gpro_undo_handler not in bpy.app.handlers.undo_post:
        bpy.app.handlers.undo_post.append(vieport_overlays.gpro_undo_handler)

    if vieport_overlays.gpro_redo_handler not in bpy.app.handlers.redo_post:
        bpy.app.handlers.redo_post.append(vieport_overlays.gpro_redo_handler)

    if vieport_overlays.gpro_scene_update in bpy.app.handlers.depsgraph_update_post:
        bpy.app.handlers.depsgraph_update_post.remove(vieport_overlays.gpro_scene_update)

    if vieport_overlays.handler_reset_edit_bbox in bpy.app.handlers.depsgraph_update_post:
        bpy.app.handlers.load_pre.remove(vieport_overlays.handler_reset_edit_bbox)
    #### Edite MOde BBox Updates


    # from .key_map_prefs import unregister_keymap
    gp_props.unregister_props()

    auto_load.unregister()


if __name__ == "__main__":
    register()
